<template>
  <div id="boardDetailPage">
    <div class="backIcon" @click="goBack">
        <i class="icon-font-v1 icon-font-fanhui"></i>
    </div>
    <div style="height: 65px;width: 1px"/>
    <div class="content">
        <div class="avatar"  @click="routeTo('user?userId='+boardDetail.sender.userId)">
            <el-avatar :src="boardDetail.sender.avatar"/>
        </div>
      <div class="box" id="contentMain">
        <div class="senderName">{{boardDetail.sender.nickName}}</div>
        <div class="blueSeparate"></div>
        <div class="title">{{boardDetail.title}}</div>
        <div class="timeRow">
          <div class="timeIcon"></div>
          <div class="time">{{boardDetail.time}}</div>
        </div>
        <div class="contentText">{{boardDetail.content}}</div>
        <div v-if="boardDetail.images.length > 0" class="imageContainer">
          <el-image class="contentImage" v-for="(image, index) in boardDetail.images" :key="index" :src="image" @click="callImagePreviewer(index)"/>
        </div>
      </div>
      <div class="box" id="members">
        <div class="memberTitle">
          <div style="font-size: 14px; font-weight: bold;">谁参与了</div>
          <div style="flex-grow: 1;"/>
          <div >{{boardDetail.member.length}}/{{boardDetail.maxNum}}</div>
        </div>
        <div style="margin-top: 7px; margin-bottom: 16px; width: 100%; height: 1px; background-color: #eee"/>
        <div v-if="boardDetail.member.length===0" style="font-size: 12px; color: #959595; text-align: center;">
          暂时还没有人参加哦...
        </div>
        <div v-else class="memberList">
          <div class="memberItem" v-for="(member, index) in boardDetail.member" :key="index" @click="routeTo('user?userId='+member.userId)">
            <el-avatar class="memberAvatar" :src="member.avatarUrl"></el-avatar>
            <div class="nickName">{{member.userName}}</div>
          </div>
        </div>
      </div>
    </div>
    <div class="bottomBar" v-if="!boardDetail.createdBySelf">
      <div v-if="boardDetail.collected===false" class="bottomBarBtn" @click="collect">
        <div class="icon star"/>
        <div class="text">收 藏</div>
      </div>
      <div v-else class="bottomBarBtn" @click="uncollect">
        <div class="icon star2" />
        <div class="text">取 消 收 藏</div>
      </div>
      <div v-if="!boardDetail.joined" class="bottomBarBtn" style="background-color: #8FC31F;" @click="attend">
        <div class="text">现 在 参 加</div>
      </div>
      <div v-else class="bottomBarBtn" style="background-color: #F56C6C;" @click="exit">
        <div class="text">退 出</div>
      </div>
    </div>
  </div>
</template>

<script>
import {ImagePreview} from 'vant'
let getMyDateString = date => {
  return `${date.getFullYear()}-${date.getMonth() + 1}-${date.getDate()} ${date.getHours()}:${date.getMinutes()}`
}
export default {
  name: 'BoardDetailTmpNew',
  data () {
    return {
      boardDetail: {
        createdBySelf: false,
        joined: false,
        collected: false,
        boardId: 0,
        sender: {
          avatar: '',
          nickName: ''
        },
        title: '',
        time: '',
        content: '',
        images: [],
        maxNum: 'MAX',
        member: [],
      }
    }
  },
  computed: {
    logged () {
      return this.$store.getters['userInfo/logged']
    },
    userBasicInfo () {
      return this.$store.state.userInfo.detail
    }
  },
  mounted: function () {
    this.refreshData()
  },
  methods: {
    goBack () {
      console.log(-1)
      this.$router.go(-1)
    },
    routeTo(path) {
        this.$router.push(path);
    },
    collect () {
      this.$api.collect(this.boardDetail.boardId, this.userBasicInfo.userId)
        .then(() => {
          this.refreshData()
        })
    },
    uncollect () {
      this.$api.uncollect(this.boardDetail.boardId, this.userBasicInfo.userId)
        .then(() => {
          this.refreshData()
        })
    },
    attend () {
      this.$api.attend(this.boardDetail.boardId, this.userBasicInfo.userId)
        .then(() => {
          this.refreshData()
        })
    },
    exit () {
      this.$api.exit(this.boardDetail.boardId, this.userBasicInfo.userId)
        .then(() => {
          this.refreshData()
        })
    },
    refreshData () {
      let params = this.$route.query
      console.log(params)
      if (params.id) {
        this.$api.getBoardDetail(params.id)
          .then(res => {
            let data = res.data.data
            this.boardDetail.boardId = params.id
            this.boardDetail.createdBySelf = this.logged ? data.userId === this.$store.state.userInfo.detail.userId : true
            this.boardDetail.title = data.title
            this.boardDetail.time = getMyDateString(new Date(data.gmtCreate))
            this.boardDetail.content = data.content
            this.boardDetail.images = data.relatedImage ? data.relatedImage : []
            this.boardDetail.maxNum = data.userCount
            this.boardDetail.collected = data.isCollected
            this.boardDetail.joined = data.isAttended
            return this.$api.userInfo(data.userId)
          })
          .then(res => {
            let data = res.data.data
            this.boardDetail.sender = {
              userId: data ? data.userId : null,
              avatar: data ? data.profilePhotoUrl : '',
              nickName: data ? data.name : ''
            }
            return this.$api.getBoardAttenders(params.id)
          })
          .then(res => {
            this.boardDetail.member = res.data.data
          })
      } else {
        this.$message.error('网络错误！')
      }
    },
    callImagePreviewer(startPos){
        let that = this;
        ImagePreview({
            images: that.boardDetail.images,
            startPosition: startPos
        });
    }
  }
}
</script>

<style scoped lang="less">
  #boardDetailPage {
    width: 100vw;
    height: 100vh;
    background-color: #3F72F6;
    position: relative;
    .backIcon {
        position: absolute;
        width: 13.5px;
        height: 18.5px;
        left: 10px;
        top: 20px;
        i{
            font-size: 30px;
            color: #ffffff;
        }
    }
    .content {
      position: relative;
      display: flex;
      flex-direction: column;
      align-items: stretch;
      min-height: calc(100vh - 125px);
      background-color: #DEDEDE;
      border-radius: 7.5px;
      overflow: visible;
      .avatar {
        position: absolute;
        top: -24.5px;
        width: 49px;
        height: 49px;
        align-self: center;
        *{
            width: 100%;
            height: 100%;
        }
      }
      .box {
        &#contentMain {
          padding-block-start: 36px;
          padding-block-end: 16px;
          min-height: 35vh;
          .senderName {
            color: #313131;
            text-align: center;
            font-size: 11px;
          }
          .blueSeparate {
            width: 25px;
            height: 2px;
            background-color: #3170FF;
            margin: 4px auto 18px auto;
          }
          .title {
            color: #313131;
            font-size: 18px;
            font-weight: bold;
            margin-bottom: 16px;
          }
          .timeRow {
            display: flex;
            flex-direction: row;
            margin-bottom: 17px;
            .timeIcon {
              width: 13px;
              height: 13px;
              background-image: url("../assets/detail/time.png");
              background-size: contain;
              margin-inline-end: 8px;
            }
            .time {
              color: #A7A7A7;
              font-size: 11px;
              line-height: 13px;
            }
          }
          .contentText {
            color: #313131;
            font-size: 14px;
            line-height: 1.7em;
            margin-bottom: 20px;
          }
          .imageContainer {
            display: flex;
            justify-content: space-around;
            width: 100%;
            .contentImage {
              width: 100px;
              height: 100px;
            }
          }
        }
        &#members {
          padding-block-start: 16px;
          padding-block-end: 18px;
          .memberTitle {
            width: 100%;
            display: flex;
            flex-direction: row;
            justify-content: space-around;
            div {
              font-size: 14px;
              color: #555;
              font-weight: bold;
            }
          }
          .memberList {
            margin: 0 auto;
            display: block;
            .memberItem {
              display: flex;
              flex-direction: row;
              &:nth-child(1n+2) {
                margin-top: 8px;
              }
              .memberAvatar {
                width: 28px;
                height: 28px;
              }
              .nickName {
                font-size: 12px;
                line-height: 28px;
                color: #959595;
                margin-inline-start: 12px;
              }
            }
          }
        }
        &:nth-child(1n+3) {
          margin-block-start: 6px;
        }
        &:last-child {
          border-bottom-left-radius: 7.5px;
          border-bottom-right-radius: 7.5px;
        }
        padding-inline-start: 32px;
        padding-inline-end: 32px;

        border-top-left-radius: 7.5px;
        border-top-right-radius: 7.5px;
        background-color: white;
      }
      padding-block-end: 65px;
    }
    .bottomBar {
      position: fixed;
      bottom: 0;
      left: 0;
      right: 0;
      height: 60px;
      display: flex;
      flex-direction: row;
      .bottomBarBtn {
        flex: 1;
        display: flex;
        align-items: center;
        justify-content: center;
        font-size: 19px;
        font-weight: bold;
        &:nth-child(0n+1) {
          background-color: white;
          .icon.star {
            height: 22px;
            width: 22px;
            background-image: url("../assets/detail/star.png");
            background-size: contain;
            background-repeat: no-repeat;
          }
          .icon.star2 {
            height: 22px;
            width: 22px;
            background-image: url("../assets/detail/star2.png");
            background-size: contain;
            background-repeat: no-repeat;
          }
          .text {
            margin-inline-start: 15px;
            color: #787878;
          }
        }
        &:nth-child(0n+2) {
          color: white;
        }
      }
    }
  }
</style>
